program myAdo;
{$APPTYPE CONSOLE}
{$IFDEF FPC}
  {$mode objfpc}{$H+}
{$ENDIF}
uses ado;

function IIF(b: boolean; sTrue: string; sFalse: string = ''): string;
begin if b then result := sTrue else result := sFalse; end;

var
  cn: TADOConnection;
  rs: TADORecordset;
  s: string;
  i: integer;
begin
  //connect db
  cn := TADOConnection.Create(nil);
{ $ifdef access} // Access over MS Jet OLEDB
  cn.Open('Provider=Microsoft.Jet.OLEDB.4.0;Data Source=test.mdb');
{ $endif}
{$ifdef mysqlnew} // MySQL ODBC 5.2
  cn.Open('Provider=MSDASQL;DRIVER={MySQL ODBC 5.2a Driver};SERVER=localhost;DATABASE=testsql;UID=root;PWD=root;');
{$endif}
{$ifdef mysqlold} // MySQL ODBC 3.51
  cn.Open('Provider=MSDASQL.1;Extended Properties="Driver={MySQL ODBC 3.51 Driver};Server=localhost;Port=3306;Database=testsql;User=root;Password=root;Option=3;"');
{$endif}  
{$ifdef mysql} // MSSQL
  cn.Open('Provider=SQLOLEDB.1;Initial Catalog=TestDB;Data Source=localhost;Persist Security Info=False;User ID=root;Password=root;');
{$endif}
{$ifdef mysqlexpress} // MSSQL Express 2008
  cn.Open('Provider=SQLNCLI10.1;Initial Catalog=TestDB;Data Source=localhost\SQLEXPRESS;Persist Security Info=False;User ID=root;Password=root;');
{$endif}
//select
  rs := TADORecordset.Create(cn);
  rs.Open('SELECT * FROM testTable');
  s := '';
  //list fieldnames
  for i:=0 to rs.Fields.count-1 do
    s := s + IIF(i>0, ';') + rs.Fields[i].Name;
  s := s + #13#10;
  //list values
  while not rs.eof do
  begin
    for i:=0 to rs.Fields.count-1 do
      s := s + IIF(i>0, ';') + rs.Fields[i].AsString;
    s := s + #13#10;
    rs.MoveNext;
  end;
  WriteLn(s);
  //close recordset
  rs.Close;
  rs.Free;
  //close connection;
  cn.Close;
  cn.Free;
end.
